#include "smtp.h"


int _smtp_out_packets_message_admin(smtpp par,int liType,char *lcJID, char *lcMSG)
   {
   int liProcess=0;
   char *lcSep, *lcRes, *lcData, *lcNS;
   xmlnode loAdmin,loJID;

   
   switch (liType)
      {
	  case SMTP_ADMIN_JID:
           lcNS=SMTP_ADMIN_NS_JID;
	       break;

      default:
           lcNS=SMTP_ADMIN_NS_EMAIL;

      }

   // Nyn otestuj pjemce, zda to nen admin
   // pokud ano, pak jeho zprvu zpracuj
   // jinak vra Invalid Address

   for (loAdmin = xmlnode_get_firstchild(xmlnode_get_tag(par->sin->config,"core/admins")); loAdmin != NULL; loAdmin = xmlnode_get_nextsibling(loAdmin))
        {
        if (loAdmin->type!=NTYPE_TAG || strcmp(xmlnode_get_attrib(loAdmin,"xmlns"),lcNS)!=0 )  
           continue;

        if (strcmp(lcJID,xmlnode_get_data(loAdmin))==0)
           {
           liProcess=1;
           break;
           }
        }


   if (liProcess==1)
      {
      // read first line from message
      lcSep = strstr(lcMSG,"\r");
      if (lcSep==NULL)
          lcSep = strstr(lcMSG,"\n");

      if (lcSep!=NULL)
          *lcSep='\0';

      // Read JID and Data from message
      lcData = strstr(lcMSG," ");
      if (lcData!=NULL)
         {
         *lcData='\0';
         lcData++;

         lcRes = strstr(lcMSG,"/");
         if (lcRes!=NULL)
            {
            *lcRes='\0';
            lcRes++;

            if (strcmp(lcRes,"paid")==0)
               {
               // Get JID item from roster
               loJID=smtp_roster_get_item(par, lcMSG,1);
               xmlnode_put_attrib(loJID,"paid",strcmp(lcData,"Y")==0?"1":"0");
               smtp_roster_set_item(par, lcMSG,loJID);
               }
            }
         }
      }

   return liProcess;
   }


int smtp_out_packets_message_admin(smtpp par,char *lcType)
   {
   jpacket jp=par->jp;
   char *lcJID, *lcMSG;

   lcJID=smtp_GetJID(par,jid_full(jp->from));
   lcMSG=xmlnode_get_tag_data(jp->x,"body");

   return _smtp_out_packets_message_admin(par,SMTP_ADMIN_JID,lcJID,lcMSG);
   }
